/*
 * Pan - A Newsreader for X
 * Copyright (C) 1999  Pan Development Team (pan@superpimp.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

#ifndef __TASK_BODY__H__
#define __TASK_BODY__H__

#include "task.h"
#include "group.h"
#include "article.h"

#define TASK_BODY(obj) ((TaskBody*)(obj))

typedef struct _TaskBody TaskBody;

struct _TaskBody
{
	/* parent class */
	Task task;

	/* private, passed in ctor */
	group_data *gdata;
	article_data *adata;
	gboolean open_in_new_window;
	MessageWindowType message_window_type;

	/* private internal */
	gboolean checkout;
};

/**
***  PUBLIC
**/

PanObject* task_body_new (server_data            * sdata,
                          group_data             * gdata,
                          article_data           * adata,
                          gboolean                 open_in_new_window,
                          MessageWindowType        message_window_type);


PanObject* task_body_new_defaults (server_data   * sdata,
                                   group_data    * gdata,
                                   article_data  * adata );


#endif /* __TASK_BODY__H__ */
